<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for app\procedural.py: 0%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">
<div id="header">
    <div class="content">
        <h1>Coverage for <b>app\procedural.py</b> :
            <span class="pc_cov">0%</span>
        </h1>
        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />
        <h2 class="stats">
            46 statements &nbsp;
            <span class="run shortkey_r button_toggle_run">0 run</span>
            <span class="mis show_mis shortkey_m button_toggle_mis">46 missing</span>
            <span class="exc show_exc shortkey_x button_toggle_exc">0 excluded</span>
        </h2>
    </div>
</div>
<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>
<div id="source">
    <p id="t1" class="mis show_mis"><span class="n"><a href="#t1">1</a></span><span class="t"><span class="key">import</span> <span class="nam">copy</span>&nbsp;</span><span class="r"></span></p>
    <p id="t2" class="pln"><span class="n"><a href="#t2">2</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t3" class="pln"><span class="n"><a href="#t3">3</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t4" class="mis show_mis"><span class="n"><a href="#t4">4</a></span><span class="t"><span class="key">def</span> <span class="nam">advice</span><span class="op">(</span><span class="nam">agents</span><span class="op">,</span> <span class="nam">n</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t5" class="mis show_mis"><span class="n"><a href="#t5">5</a></span><span class="t">    <span class="key">if</span> <span class="key">not</span> <span class="nam">n</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t6" class="mis show_mis"><span class="n"><a href="#t6">6</a></span><span class="t">        <span class="key">return</span> <span class="op">[</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t7" class="pln"><span class="n"><a href="#t7">7</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t8" class="pln"><span class="n"><a href="#t8">8</a></span><span class="t">    <span class="com"># Criando a matrix</span>&nbsp;</span><span class="r"></span></p>
    <p id="t9" class="mis show_mis"><span class="n"><a href="#t9">9</a></span><span class="t">    <span class="nam">row</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t10" class="mis show_mis"><span class="n"><a href="#t10">10</a></span><span class="t">    <span class="nam">column</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t11" class="mis show_mis"><span class="n"><a href="#t11">11</a></span><span class="t">    <span class="key">for</span> <span class="nam">x</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="nam">n</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t12" class="mis show_mis"><span class="n"><a href="#t12">12</a></span><span class="t">        <span class="key">for</span> <span class="nam">y</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="nam">n</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t13" class="mis show_mis"><span class="n"><a href="#t13">13</a></span><span class="t">            <span class="nam">row</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="op">[</span><span class="nam">x</span><span class="op">,</span> <span class="nam">y</span><span class="op">]</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t14" class="mis show_mis"><span class="n"><a href="#t14">14</a></span><span class="t">        <span class="nam">column</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">row</span><span class="op">.</span><span class="nam">copy</span><span class="op">(</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t15" class="mis show_mis"><span class="n"><a href="#t15">15</a></span><span class="t">        <span class="nam">row</span><span class="op">.</span><span class="nam">clear</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t16" class="mis show_mis"><span class="n"><a href="#t16">16</a></span><span class="t">    <span class="nam">matrix</span> <span class="op">=</span> <span class="nam">copy</span><span class="op">.</span><span class="nam">deepcopy</span><span class="op">(</span><span class="nam">column</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t17" class="pln"><span class="n"><a href="#t17">17</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t18" class="mis show_mis"><span class="n"><a href="#t18">18</a></span><span class="t">    <span class="key">if</span> <span class="key">not</span> <span class="nam">agents</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t19" class="mis show_mis"><span class="n"><a href="#t19">19</a></span><span class="t">        <span class="key">return</span> <span class="nam">matrix</span>&nbsp;</span><span class="r"></span></p>
    <p id="t20" class="pln"><span class="n"><a href="#t20">20</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t21" class="pln"><span class="n"><a href="#t21">21</a></span><span class="t">    <span class="com"># Adicionando agentes</span>&nbsp;</span><span class="r"></span></p>
    <p id="t22" class="mis show_mis"><span class="n"><a href="#t22">22</a></span><span class="t">    <span class="key">for</span> <span class="nam">agent</span> <span class="key">in</span> <span class="nam">agents</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t23" class="mis show_mis"><span class="n"><a href="#t23">23</a></span><span class="t">        <span class="key">for</span> <span class="nam">x</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="nam">n</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t24" class="mis show_mis"><span class="n"><a href="#t24">24</a></span><span class="t">            <span class="key">for</span> <span class="nam">y</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="nam">n</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t25" class="mis show_mis"><span class="n"><a href="#t25">25</a></span><span class="t">                <span class="key">if</span> <span class="nam">matrix</span><span class="op">[</span><span class="nam">x</span><span class="op">]</span><span class="op">[</span><span class="nam">y</span><span class="op">]</span> <span class="op">==</span> <span class="nam">list</span><span class="op">(</span><span class="nam">agent</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t26" class="mis show_mis"><span class="n"><a href="#t26">26</a></span><span class="t">                    <span class="nam">matrix</span><span class="op">[</span><span class="nam">x</span><span class="op">]</span><span class="op">[</span><span class="nam">y</span><span class="op">]</span> <span class="op">=</span> <span class="op">[</span><span class="num">0</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t27" class="pln"><span class="n"><a href="#t27">27</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t28" class="pln"><span class="n"><a href="#t28">28</a></span><span class="t">    <span class="com"># Tornando os espa&#231;os vazios</span>&nbsp;</span><span class="r"></span></p>
    <p id="t29" class="mis show_mis"><span class="n"><a href="#t29">29</a></span><span class="t">    <span class="key">for</span> <span class="nam">x</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="nam">n</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t30" class="mis show_mis"><span class="n"><a href="#t30">30</a></span><span class="t">        <span class="key">for</span> <span class="nam">y</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="nam">n</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t31" class="mis show_mis"><span class="n"><a href="#t31">31</a></span><span class="t">            <span class="key">if</span> <span class="nam">matrix</span><span class="op">[</span><span class="nam">x</span><span class="op">]</span><span class="op">[</span><span class="nam">y</span><span class="op">]</span> <span class="op">!=</span> <span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t32" class="mis show_mis"><span class="n"><a href="#t32">32</a></span><span class="t">                <span class="nam">matrix</span><span class="op">[</span><span class="nam">x</span><span class="op">]</span><span class="op">[</span><span class="nam">y</span><span class="op">]</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t33" class="pln"><span class="n"><a href="#t33">33</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t34" class="pln"><span class="n"><a href="#t34">34</a></span><span class="t">    <span class="com"># Realizando calculo dos agentes</span>&nbsp;</span><span class="r"></span></p>
    <p id="t35" class="mis show_mis"><span class="n"><a href="#t35">35</a></span><span class="t">    <span class="key">for</span> <span class="nam">x</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="nam">n</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t36" class="mis show_mis"><span class="n"><a href="#t36">36</a></span><span class="t">        <span class="key">for</span> <span class="nam">y</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="nam">n</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t37" class="mis show_mis"><span class="n"><a href="#t37">37</a></span><span class="t">            <span class="key">if</span> <span class="nam">matrix</span><span class="op">[</span><span class="nam">x</span><span class="op">]</span><span class="op">[</span><span class="nam">y</span><span class="op">]</span> <span class="op">!=</span> <span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t38" class="mis show_mis"><span class="n"><a href="#t38">38</a></span><span class="t">                <span class="key">for</span> <span class="nam">agent</span> <span class="key">in</span> <span class="nam">agents</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t39" class="mis show_mis"><span class="n"><a href="#t39">39</a></span><span class="t">                    <span class="nam">x_agent</span><span class="op">,</span> <span class="nam">y_agent</span> <span class="op">=</span> <span class="nam">agent</span>&nbsp;</span><span class="r"></span></p>
    <p id="t40" class="mis show_mis"><span class="n"><a href="#t40">40</a></span><span class="t">                    <span class="nam">x_matriz</span><span class="op">,</span> <span class="nam">y_matriz</span> <span class="op">=</span> <span class="nam">x</span><span class="op">,</span> <span class="nam">y</span>&nbsp;</span><span class="r"></span></p>
    <p id="t41" class="mis show_mis"><span class="n"><a href="#t41">41</a></span><span class="t">                    <span class="nam">distance</span> <span class="op">=</span> <span class="nam">abs</span><span class="op">(</span><span class="nam">x_matriz</span> <span class="op">-</span> <span class="nam">x_agent</span><span class="op">)</span> <span class="op">+</span> <span class="nam">abs</span><span class="op">(</span><span class="nam">y_matriz</span> <span class="op">-</span> <span class="nam">y_agent</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t42" class="mis show_mis"><span class="n"><a href="#t42">42</a></span><span class="t">                    <span class="nam">matrix</span><span class="op">[</span><span class="nam">x</span><span class="op">]</span><span class="op">[</span><span class="nam">y</span><span class="op">]</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">distance</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t43" class="pln"><span class="n"><a href="#t43">43</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t44" class="pln"><span class="n"><a href="#t44">44</a></span><span class="t">            <span class="com"># Receber o menor valor de distancia</span>&nbsp;</span><span class="r"></span></p>
    <p id="t45" class="mis show_mis"><span class="n"><a href="#t45">45</a></span><span class="t">            <span class="op">(</span><span class="nam">matrix</span><span class="op">[</span><span class="nam">x</span><span class="op">]</span><span class="op">[</span><span class="nam">y</span><span class="op">]</span><span class="op">)</span> <span class="op">=</span> <span class="nam">min</span><span class="op">(</span><span class="nam">matrix</span><span class="op">[</span><span class="nam">x</span><span class="op">]</span><span class="op">[</span><span class="nam">y</span><span class="op">]</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t46" class="pln"><span class="n"><a href="#t46">46</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t47" class="pln"><span class="n"><a href="#t47">47</a></span><span class="t">    <span class="com"># Retornar o lugar seguro</span>&nbsp;</span><span class="r"></span></p>
    <p id="t48" class="mis show_mis"><span class="n"><a href="#t48">48</a></span><span class="t">    <span class="nam">safe_place</span> <span class="op">=</span> <span class="op">[</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t49" class="mis show_mis"><span class="n"><a href="#t49">49</a></span><span class="t">    <span class="key">for</span> <span class="nam">x</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="nam">n</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t50" class="mis show_mis"><span class="n"><a href="#t50">50</a></span><span class="t">        <span class="key">for</span> <span class="nam">y</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="nam">n</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t51" class="mis show_mis"><span class="n"><a href="#t51">51</a></span><span class="t">            <span class="key">if</span> <span class="nam">matrix</span><span class="op">[</span><span class="nam">x</span><span class="op">]</span><span class="op">[</span><span class="nam">y</span><span class="op">]</span> <span class="op">==</span> <span class="nam">max</span><span class="op">(</span><span class="nam">matrix</span><span class="op">[</span><span class="nam">x</span><span class="op">]</span><span class="op">)</span> <span class="key">and</span> <span class="nam">matrix</span><span class="op">[</span><span class="nam">x</span><span class="op">]</span><span class="op">[</span><span class="nam">y</span><span class="op">]</span> <span class="op">==</span> <span class="nam">max</span><span class="op">(</span><span class="nam">matrix</span><span class="op">[</span><span class="nam">y</span><span class="op">]</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t52" class="mis show_mis"><span class="n"><a href="#t52">52</a></span><span class="t">                <span class="nam">safe_place</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="op">(</span><span class="nam">x</span><span class="op">,</span> <span class="nam">y</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t53" class="mis show_mis"><span class="n"><a href="#t53">53</a></span><span class="t">    <span class="nam">count</span> <span class="op">=</span> <span class="num">0</span>&nbsp;</span><span class="r"></span></p>
    <p id="t54" class="mis show_mis"><span class="n"><a href="#t54">54</a></span><span class="t">    <span class="key">for</span> <span class="nam">x</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="nam">n</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t55" class="mis show_mis"><span class="n"><a href="#t55">55</a></span><span class="t">        <span class="key">for</span> <span class="nam">y</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="nam">n</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t56" class="mis show_mis"><span class="n"><a href="#t56">56</a></span><span class="t">            <span class="key">if</span> <span class="nam">matrix</span><span class="op">[</span><span class="nam">x</span><span class="op">]</span><span class="op">[</span><span class="nam">y</span><span class="op">]</span> <span class="op">==</span> <span class="num">0</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t57" class="mis show_mis"><span class="n"><a href="#t57">57</a></span><span class="t">                <span class="nam">count</span> <span class="op">+=</span> <span class="num">1</span>&nbsp;</span><span class="r"></span></p>
    <p id="t58" class="mis show_mis"><span class="n"><a href="#t58">58</a></span><span class="t">    <span class="key">if</span> <span class="nam">count</span> <span class="op">==</span> <span class="nam">n</span> <span class="op">*</span> <span class="nam">n</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t59" class="mis show_mis"><span class="n"><a href="#t59">59</a></span><span class="t">        <span class="key">return</span> <span class="op">[</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t60" class="pln"><span class="n"><a href="#t60">60</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t61" class="mis show_mis"><span class="n"><a href="#t61">61</a></span><span class="t">    <span class="key">return</span> <span class="nam">safe_place</span>&nbsp;</span><span class="r"></span></p>
    <p id="t62" class="pln"><span class="n"><a href="#t62">62</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t63" class="mis show_mis"><span class="n"><a href="#t63">63</a></span><span class="t"><span class="nam">print</span><span class="op">(</span><span class="nam">advice</span><span class="op">(</span><span class="op">[</span><span class="op">(</span><span class="num">0</span><span class="op">,</span><span class="num">0</span><span class="op">)</span><span class="op">,</span> <span class="op">(</span><span class="num">1</span><span class="op">,</span><span class="num">1</span><span class="op">)</span><span class="op">]</span><span class="op">,</span> <span class="num">10</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
</div>
<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v5.0.3</a>,
            created at 2020-01-20 09:26
        </p>
    </div>
</div>
</body>
</html>
